<?

/*

   Autores:  Pablo Costa <pablo@shark.ib.usp.br>
   Data: 23/09/2000

   Voc pode distribuir, utilizar e alterar livremente estas rotinas desde
   que mantenha este comentrio que identifica o autor original.

   You should have received a copy of the GNU Public
   License along with this package; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

*/                  

/* 

A febraban definiu a seguinte formatacao para o codigo de barras:

Posio         Contedo
1 a 3           Nmero do banco
4               Cdigo da Moeda - 9 para Real
5               Digito verificador do Cdigo de Barras
6  a 19         Valor (12 inteeeiros e 2 decimais)
20 a 44         Campo Livre definido por cada banco           

Layout para o Santander composto por 6 campos: 

 1  | 2 | 3  |   4   |    5    |        6       |      7       |   8

353 | 9 | dv | valor | agencia | conta_corrente | nosso_numero | livre 

1 = codigo do banco
2 = Moeda sempre 9
3 = 3 digito verificador geral
4 = valor com 14 digitos (colocar zeros a esquerda)
5 = Agencia com 4 digitos
6 = Conta corrente com 8 digitos 
7 = Nosso numero com 8 digitos 
8 = livre com 5 digitos 


Ps: ate o campo 4 a regra eh a mesma para todos os bancos, 
so mudando o codigo do banco.

*/

/* Montagem do calculo para o nosso numero */
$agencia = substr($agcod,0,3);
$contacedente = substr($agcod,4,6);

$nnstring = "$agencia$contacedente$nnum";

$dv1 = Modulo11($nnstring);

$nnstring = "$nnstring$dv1";
$dv2 = Modulo11($nnstring);




/* formatacao do numero para o codigo de barras  */

$v = ereg_replace("R\\$","",$vcobr); // Caso o valor venha no formato R$ nn,nn remove o R$
$vcobr= $v;
$v = ereg_replace(chr(44),"",$v);    // Remove a virgula
$valor = sprintf("%010d",$v);	     // Formata o valor

/* vencimento */
if(!empty($dvence)){
$vcto = "$dvence/$mvence/$avence";
}
else {
$vence = explode("/", $vcto);
$dvence = $vence[0];
$mvence = $vence[1];
$avence = $vence[2];
$vcto = "$dvence/$mvence/$avence";
}
$fatorvcto = fatorvenc($avence,$mvence,$dvence);    

$nnum = intval($nnum);
$nn = "$nnum$dv1$dv2";
$moeda = "9";
$codbank = 353;      
$dvcampo = "$codbank$moeda$fatorvcto$valor$agcod$nn" . "00000"; // 43 numeros para o calculo do digito verificador

$dv =  Modulo11($dvcampo);

$num = "$codbank$moeda$dv$fatorvcto$valor$agcod$nn" . "00000"; // Numero para o codigo de barras com 44 digitos


/* Devolve a linha digitavel */

$str = $num;
$linha =  MontaLinha ($str);


/* 
- Codigo do banco que aparece no topo do boleto
- Devolve o codigo do banco com o seu digito verificador. Ex para 479, devolve 479-0 
*/

$bankcode = ShowBankcode($codbank);  


/*

Para os parametros abaixo vc pode estabelecer um padrao, caso
as variaves nao sejam fornecidas

*/


/* Nome do Banco */
$bank = "Santander";

/* cedente */
$cdte ? "":  $cdte = "PHPBoleto";

/* vencimento */
if(!empty($dvence)){
$vcto = "$dvence/$mvence/$avence";
}
else {
$datatual = Time();
$dia = (24 * 3600);
$depois = $datatual + (7 * $dia);
$vcto = date( "d/m/Y", $depois);  
}


/* nosso numero */
$nnum = "$nn";

/* numero documento *
$ndoc ? "": $ndoc = "";

/* especie documento */
$edoc ? "": $edoc = "";

/* data do documento */
$useDate = Time();
$ddoc ? "": $ddoc = date( "d/m/Y", $useDate);



/* agencia/codigo cedente */
$p1 = substr($agcod,0,3);
$p2 = substr($agcod,3,1);
$p3 = substr($agcod,4,8); 
$agcod = "$p1-$p2/$p3"; 

/* Valor do documento */
$vdoc ? "": $vdoc = "$vcobr";
unset($vcobr);

/* Valor cobrado */
$vcobr ? "": $vcobr = "";


/* Sacado */
$sacado ? "": $sacado = "";

/* CPF */
$cpf ? "": $cpf = "";

/* Local de Pagamento */
$lp ? "": $lp = "Pagavel em qualquer banco";
                                         

/* Sacador */
$sacador ? "": $sacador = "";


/* Aceite */
$act ? "": $act = "";


/* data do processamento */
$dproc ? "": $dproc = "";


/* carteira */
$cart ? "": $cart = "";


/*  Especificacao moeda */
$espmoed ? "": $espmoed = "R$";


/* quantidade */
$qtde ? "": $qtde = "";


/* valor da moeda */
$vmoed ? "": $vmoed = "";


/* descontos */
$desc ? "": $desc = "";


/* outras deducoes */
$ddc ? "": $ddc = "";


/* mora / multa */
$multa ? "": $multa = "";


/* outros acrescimos */
$acres ? "": $acres = "";


/* instrucoes */
$instr1 ? "": $instr1 = "";
$instr2 ? "": $instr2 = "";
$instr3 ? "": $instr3 = "";
$instr4 ? "": $instr4 = "";
$instr5 ? "": $instr5 = "";


/* Espcificacao do doc */
$edoc ? "": $edoc = "";

/* Uso do Banco */
$usobc ? "": $usobc = "";

?>
